{*******************************************************************************
CashGrabber V1.0
CashGrabber, ist ein bot für den 4.Programmierwettbewerb von freies Magazin.
Copyright (C) 2011  Ingo Steiniger

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, see <http://www.gnu.org/licenses/>.
*******************************************************************************}
program CashGrabber;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes, SysUtils, CustApp
  { you can add units after this };

const myVersion='CashGrabber V1.0';

type
  TCGRes = Record
    hisOffer, myOffer : Integer;
    hisAnswer, myAnswer: Boolean;
  end;


  { TCashGrabber }

  TCashGrabber = class(TCustomApplication)
  protected
    procedure DoRun; override;
  public
    F, FD:Text;
    CGDebug:Boolean;
    CGRounds:Integer;
    CGCurRound:Integer;
    CGmyCash:Integer;
    CGhisCash:Integer;
    CGmyLastOffer:Integer;
    CGhisLastOffer:Integer;
    CGmaxOffer:Integer;
    CGallP:Integer;
    CGEnd:Boolean;
    aCGRes: Array of TCGRes;
    constructor Create(TheOwner: TComponent); override;
    destructor Destroy; override;
    function CGMakeOffer():Integer;
    function CGAnswerOffer(CGOffer:Integer):Boolean;
    function CGgetHisLowYES():Integer;
    function CGgetHisHighNO():Integer;
  end;

{ TCashGrabber }

//***Programmablauf***
procedure TCashGrabber.DoRun;
var
  CGInput, CGCmd, CGVal, CGPath:String;
  CGmyAnswer:Boolean;
begin

  //Inits
  AssignFile(F, '');
  ReWrite(F);


  //Parameter checken
  if HasOption('help') or HasOption('-help') or HasOption('h') or HasOption('-h') then
  begin
    WriteLn(F, myVersion);
    WriteLn(F, 'Copyright (C) 2011  Ingo Steiniger');
    WriteLn(F, 'Lizenz: GPLv3 or any later');
    WriteLn(F, '');
    WriteLn(F, 'CashGrabber, ist ein bot für den 4.Programmierwettbewerb von freies Magazin.');
  end else
  begin
    CGPath:=ExtractFilePath(Paramstr(0));
    Randomize;
    CGCmd:='';
    CGVal:='';
    CGmyAnswer:=False;
    CGEnd:=False;
    CGRounds:=0;
    CGCurRound:=0;
    CGmyCash:=0;
    CGhisCash:=0;
    CGmyLastOffer:=0;
    CGhisLastOffer:=0;
    CGMaxOffer:=0;
    setlength(aCGRes, 0);

    //Parameter checken
    if HasOption('debug') then
    begin
      CGDebug:=True;
    end else
    begin
      CGDebug:=False;
    end;

    //DEBUG
    if CGDebug then
    begin
      AssignFile(FD, CGPath+PathDelim+'CGDebug.txt');
      Rewrite(FD);
    end;

    //Schleife bis ENDE oder Rundenzahl erreicht
    while (CGCmd<>'ENDE') and not CGEnd do
    begin
      //Input lesen und ggf. Antworten
      ReadLn(CGInput);
      if Pos(' ', CGInput)<>0 then
      begin
        CGCmd:=UpperCase(copy(CGInput, 1, Pos(' ', CGInput)-1));
        delete(CGInput, 1, Pos(' ', CGInput));
        CGVal:=CGInput;
      end else
      begin
        CGCmd:=UpperCase(CGInput);
        CGVal:='';
      end;

      if CGCmd='RUNDEN' then
      begin
        if tryStrToInt(CGVal, CGRounds) then
        begin
          setlength(aCGRes, CGRounds);
          CGallP:=CGRounds*2000;
        end else
        begin
          //DEBUG
          if CGDebug then
          begin
            WriteLn(FD, 'Falscher Wert! '+CGCmd+':"'+CGVal+'"');
            Flush(FD);
          end;
        end;
      end;

      if CGCmd='RUNDE' then
      begin
        if tryStrToInt(CGVal, CGCurRound) then
        begin
          if CGCurRound>CGRounds then
            CGEnd:=True;
          //DEBUG
          if CGDebug then
          begin
            writeln(FD, IntToStr(CGcurRound));
          end;
        end else
        begin
          //DEBUG
          if CGDebug then
          begin
            WriteLn(FD, 'Falscher Wert! '+CGCmd+':"'+CGVal+'"');
            Flush(FD);
          end;
        end;
      end;


      if CGCmd='ANGEBOT' then
      begin
        if tryStrToInt(CGVal, CGhisLastOffer) then
        begin
          CGmyAnswer:=CGAnswerOffer(CGhisLastOffer);
          if CGmyAnswer then
          begin
            WriteLn(F, 'JA');
            Flush(F);
            CGmyCash:=CGmyCash+CGhislastOffer;
            CGhisCash:=CGhisCash+(1000-CGhisLastOffer);
            //DEBUG
            if CGDebug then
            begin
              writeLn(FD, 'he:'+IntToStr(CGhisLastOffer)+' -> JA');
            end;
          end else
          begin
            WriteLn(F, 'NEIN');
            Flush(F);
            //DEBUG
            if CGDebug then
            begin
              writeLn(FD, 'he:'+IntToStr(CGhisLastOffer)+' -> NEIN');
            end;
          end;
          //Verlauf
          aCGRes[CGcurRound-1].hisOffer:=CGhisLastOffer;
          aCGRes[CGcurRound-1].myAnswer:=CGmyAnswer;
          if CGMaxOffer<CGhisLastOffer then
            CGMaxOffer:=CGhisLastOffer;
        end else
        begin
          //DEBUG
          if CGDebug then
          begin
            WriteLn(FD, 'Falscher Wert! '+CGCmd+':"'+CGVal+'"');
            Flush(FD);
          end;
        end;
      end;

      if CGCmd='PUNKTE' then
      begin
        if CGVal='0' then
          CGallP:=CGallP-1000;
      end;

      if CGCmd='START' then
      begin
        CGmyLastOffer:=CGMakeOffer;
        WriteLn(F, IntToStr(CGmyLastOffer));
        Flush(F);
      end;

      if CGCmd='JA' then
      begin
        CGmyCash:=CGmyCash+(1000-CGmyLastOffer);
        CGhisCash:=CGhisCash+CGmyLastOffer;

        //DEBUG
        if CGDebug then
        begin
          writeLn(FD, 'me:'+IntToStr(CGmyLastOffer)+' -> JA');
        end;
        //Verlauf
        aCGRes[CGcurRound-1].myOffer:=CGmyLastOffer;
        aCGRes[CGcurRound-1].hisAnswer:=True;
      end;

      if CGCmd='NEIN' then
      begin
        //DEBUG
        if CGDebug then
        begin
          writeLn(FD, 'me:'+IntToStr(CGmyLastOffer)+' -> NEIN');
        end;
        //Verlauf
        aCGRes[CGcurRound-1].myOffer:=CGmyLastOffer;
        aCGRes[CGcurRound-1].hisAnswer:=False;
      end;
    end;

  end;
  // stop program loop
  close(F);

  //DEBUG
  if CGDebug then
  begin
    WriteLn(FD, 'myCash: '+IntToStr(CGmyCash));
    WriteLn(FD, 'hisCash: '+IntToStr(CGhisCash));
    WriteLn(FD, 'allCash: '+IntToStr(CGallP));
    Close(FD);
  end;


  setlength(aCGRes, 0);

  Terminate;
end;

constructor TCashGrabber.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);
  StopOnException:=True;
end;

destructor TCashGrabber.Destroy;
begin
  inherited Destroy;
end;

//***Eigenes Angebot berechnen***
function TCashGrabber.CGMakeOffer(): Integer;
begin
  if CGcurRound=1 then
  begin
    if CGhisLastOffer=0 then
      Result:=random(300)+100
    else
      Result:=CGhisLastOffer;
  end else
  begin
    if CGmyCash=CGhisCash then
    begin
      Result:=401;
    end;
    if CGmyCash>CGhisCash then
    begin
      Result:=round((1000*CGhisCash)/(1000+2*CGhisCash));
      if Result>400 then
        Result:=Result-100;
    end;
    if CGmyCash<CGhisCash then
    begin
      Result:=trunc((CGgetHisHighNo + CGgetHisLowYES) / 2)+1;

      //DEBUG
      if CGDebug then
        WriteLn(FD, 'LOW: '+IntToStr(CGgetHisLowYES)+' High: '+IntToStr(CGgetHisHighNo));
    end;
  end;

end;

//***Antwort auf Angebot berechnen***
function TCashGrabber.CGAnswerOffer(CGOffer: Integer): Boolean;
begin
  if (CGOffer>249) or
     ((CGOffer>=CGMaxOffer) and (CGOffer>249)) or
     (CGhisCash+(1000-CGOffer)<CGmyCash+CGOffer) then
    Result:=True
  else
    Result:=False;
end;

//***niedrigstes angenommenes Angebot finden***
function TCashGrabber.CGgetHisLowYES(): Integer;
var i,j:Integer;
begin
  Result:=500;
  j:=CGcurRound-1;
  i:=0;
  while (i<=10) and (j>=0) do
  begin
    if (aCGRes[j].myOffer<Result) and aCGRes[j].hisAnswer then
    begin
      Result:=aCGRes[j].myOffer;
      inc(i);
    end;

    dec(j);
  end;
end;

//***höchstes abgelentes Angebot finden***
function TCashGrabber.CGgetHisHighNO(): Integer;
var i,j:Integer;
begin
  Result:=0;
  j:=CGcurRound-1;
  i:=0;
  while (i<=10) and (j>=0) do
  begin
    if (aCGRes[j].myOffer>Result) and not aCGRes[j].hisAnswer then
    begin
      Result:=aCGRes[j].myOffer;
      inc(i);
    end;

    dec(j);
  end;
end;

var
  Application: TCashGrabber;

begin
  Application:=TCashGrabber.Create(nil);
  Application.Run;
  Application.Free;
end.

