/**
    (C) Copyright 2011 Dominik Wagenfuehr

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation; either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this program. If not, see
    <http://www.gnu.org/licenses/>.
*/

#include "basestrategy.hh"

// Konstruktor
BaseStrategy::BaseStrategy()
: mBotDataP(0)
{
}

// Destructor.
BaseStrategy::~BaseStrategy()
{
    // Pointer nicht loeschen, kommt von aussen!
    mBotDataP = 0;
}

// Setzt die aktuellen Daten eines Bots.
void BaseStrategy::setBotData( BotData const* botDataP )
{
    // Eine alte Zuweisung wird einfach ueberschrieben.
    // Damit kann man eine Strategie einem anderen Bot
    // zuordnen (falls man das will).
    mBotDataP = botDataP;
}
